<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        form {
            border      : 1px solid #ddd;
            padding     : 5px;
            width       : 225px;
            background  : #efefef;
        }

        label {
            display     : block;
            margin-top  : 5px;
        }

        input, textarea, select, option {
            min-width   : 200px;
        }
    </style>
</head>
<body>

    <div id="app">
        <form-component
        
        >
        </form-component>

        <br><br>
    
        <table border="1">
            <tr v-for="member in members">
                <td>
                    <img width="100" :src="member.photo_profile ? photoDomain + member.photo_profile : 'https://dummyimage.com/16:9x1080'" alt="">
                </td>
                <td>
                    <b>Name : </b> {{ member.name }} <br>
                    <b>Phone : </b> {{ member.no_hp }} <br>
                    <b>Address : </b> {{ member.address }} <br>
                </td>
                <td>
                    <button @click="editMember(member)">Edit</button>
                    <button @click="deleteMember(member.id)">Hapus</button>
                    <button @click="uploadPhoto(member)">Upload Foto</button>
                </td>
            </tr>
        </table>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://unpkg.com/vuex@3.6.2/dist/vuex.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script>
        const store = new Vuex.Store({
            state: {
                name        : '',
                phone       : '',
                address     : '',
                photoDomain : 'http://demo-api-vue.sanbercloud.com',
                buttonStatus: 'submit',
                idEditMember: null,
                idUpload    : null,
                errors      : [],
                members     : []
            },
            mutations: {
                clearForm       : function (state, payload) {
                    state.name = ''
                    state.phone = ''
                    state.address = ''

                    if (payload) {
                        state.buttonStatus = 'submit'
                        state.idEditMember = null
                        state.idUpload = null
                    }
                },
                validationForm  : function (state, payload) {
                    state.errors = []

                    if (state.name.length < 3)
                        state.errors.push('Gunakan nama lengkap anda!')

                    if (state.phone.length < 8)
                        state.errors.push('Nomor Telepon minimal 8 digit')

                    if (state.address.trim().length == 0)
                        state.errors.push('Alamat tidak boleh kosong')
                },
                editMember      : function (state, payload) {
                    state.name = payload.name
                    state.phone = payload.no_hp
                    state.address = payload.address
                    state.idEditMember = payload.id
                    state.buttonStatus = 'update'
                },
                uploadPhoto     : function (state, payload) {
                    state.name = payload.name
                    state.phone = payload.no_hp
                    state.address = payload.address
                    state.idUpload = payload.id
                    state.buttonStatus = 'upload'
                },
                updateName      : function (state, payload) {
                    state.name = payload
                },
                updatePhone     : function (state, payload) {
                    state.phone = payload
                },
                updateAddress   : function (state, payload) {
                    state.address = payload
                }
            },
            actions: {
                submitForm      : function (context, payload) {
                    context.commit('validationForm')

                    if (context.state.errors.length === 0) {
                        let formData = new FormData()
                        formData.append('name', context.state.name)
                        formData.append('address', context.state.address)
                        formData.append('no_hp', context.state.phone)

                        const config = {
                            method  : "post",
                            url     : "http://demo-api-vue.sanbercloud.com/api/member",
                            data    : formData
                        }

                        axios(config)
                            .then( (response) => {
                                context.commit('clearForm')
                                context.dispatch('getMembersData')
                                alert(response.data.message)
                            })
                            .catch( (error) => {
                                console.log(error)
                            })
                    }
                },
                updateMember    : function (context, payload) {
                    context.commit('validationForm')

                    if (context.state.errors.length === 0) {
                        let formData = new FormData()
                        formData.append('name', context.state.name)
                        formData.append('address', context.state.address)
                        formData.append('no_hp', context.state.phone)

                        const config = {
                            method : "post",
                            url : `http://demo-api-vue.sanbercloud.com/api/member/${context.state.idEditMember}`,
                            params : { _method : "PUT" },
                            data : formData
                        }

                        axios(config)
                            .then( (response) =>{
                                context.commit('clearForm', true)
                                context.dispatch('getMembersData')
                                alert(response.data.message)
                            })
                            .catch( (error) => {
                                console.log(error)
                            })
                    }
                },
                getMembersData  : function (context, payload) {
                    const config = {
                        method  : "get",
                        url     : "http://demo-api-vue.sanbercloud.com/api/member"
                    }

                    axios(config)
                        .then( (response) => {
                            context.state.members = response.data.members
                        })
                        .catch( (error) => {
                            console.log(error)
                        })
                },
                submitPhoto     : function (context, payload) {
                    let formData = new FormData()
                    formData.append('photo_profile', payload)

                    const config = {
                        method : "post",
                        url : `http://demo-api-vue.sanbercloud.com/api/member/${context.state.idUpload}/upload-photo-profile`,
                        data : formData
                    }

                    axios(config)
                        .then( (response) => {
                            context.commit('clearForm', true)
                            context.dispatch('getMembersData')
                            alert(response.data.message)
                        })
                        .catch( (error) => {
                            console.log(error)
                        })
                },
                deleteMember    : function (context, payload) {
                    const config = {
                        method : "post",
                        url : `http://demo-api-vue.sanbercloud.com/api/member/${payload}`,
                        params : { _method : "DELETE" }
                    }

                    axios(config)
                        .then( (response) => {
                            context.dispatch('getMembersData')
                            alert(response.data.message)
                        })
                        .catch( (error) => {
                            console.log(error)
                        })
                },
            },
            getters: {

            }
        })

        const FormComponent = {
            template : `
                <form @submit.prevent="submitForm">
                    <p v-if="errors.length">
                        <b>Please correct the following errors: </b>
                        <ul>
                            <li v-for="error in errors">{{ error }}</li>
                        </ul>
                    </p>
                    <label>Name: </label>
                    <input type="text" :disabled="buttons == 'upload'" name="name" ref="name" v-model="name">
                    <label>Phone: </label>
                    <input type="text" :disabled="buttons == 'upload'" name="phone" ref="phone" v-model="phone">
                    <label>Address: </label>
                    <textarea :disabled="buttons == 'upload'" name="address" ref="address" v-model="address"></textarea>
                    <div v-if="buttons == 'submit'">
                        <input type="submit" value="SUBMIT">
                    </div>
                    <div v-else-if="buttons == 'update'">
                        <input type="button" value="UPDATE" @click="updateMember">
                        <input type="button" value="CANCEL" @click="clearForm" style="margin-top:5px">
                    </div>
                    <div v-else-if="buttons == 'upload'">
                        <input type="file" name="photo" ref="photo">
                        <input type="button" value="UPLOAD" @click="submitPhoto" style="margin-top: 5px">
                        <input type="button" value="CANCEL" @click="clearForm" style="margin-top:5px">
                    </div>
                </form>
            `,
            computed: {
                errors  : function () {
                    return this.$store.state.errors
                },
                buttons  : function () {
                    return this.$store.state.buttonStatus
                },
                name    : {
                    get () {
                        return this.$store.state.name
                    },
                    set (value) {
                        this.$store.commit('updateName', value)
                    }
                },
                phone   : {
                    get () {
                        return this.$store.state.phone
                    },
                    set (value) {
                        this.$store.commit('updatePhone', value)
                    }
                },
                address : {
                    get () {
                        return this.$store.state.address
                    },
                    set (value) {
                        this.$store.commit('updateAddress', value)
                    }
                }
            },
            methods: {
                clearForm       : function () {
                    this.$store.commit("clearForm", true)
                },
                submitForm      : function () {
                    this.$store.dispatch("submitForm")
                },
                updateMember    : function () {
                    this.$store.dispatch("updateMember")
                },
                submitPhoto     : function () {
                    let file = this.$refs.photo.files[0]
                    this.$store.dispatch('submitPhoto', file)
                }
            }
        }

        const vm = new Vue({
            el: '#app',
            store,
            components : {
                'form-component' : FormComponent
            },
            computed : {
                members     : function () {
                    return this.$store.state.members
                },
                photoDomain : function () {
                    return this.$store.state.photoDomain
                }
            },
            methods: {
                deleteMember    : function (id) {
                    this.$store.dispatch('deleteMember', id)
                },
                editMember      : function (member) {
                    this.$store.commit('editMember', member)
                },
                uploadPhoto     : function (member) {
                    this.$store.commit('uploadPhoto', member)
                },
                changeName      : function (name) {
                    this.name = name
                },
                changePhone     : function (phone) {
                    this.phone = phone
                },
                changeAddress   : function (address) {
                    this.address = address
                }
            },
            created () {
                this.$store.dispatch('getMembersData')
            },
        })
    </script>

</body>
</html>